{

 (c)1998 Ronald Hendra Wibowo using Turbo Pascal 7.0
 If you need information about this program feel free to contact me.
 Mailto: Hahoho@telkom.net
 Http://www.Geocities.com/HWRonaldHW/

}

uses crt,dos,graph;

type blocktype = array [1..4,1..4,1..4] of byte;

const L:blocktype=( ((0,0,0,0),(0,1,0,0),(0,1,0,0),(0,1,1,0)),
                    ((0,0,0,0),(0,0,0,0),(0,0,0,1),(0,1,1,1)),
                    ((0,0,1,1),(0,0,0,1),(0,0,0,1),(0,0,0,0)),
                    ((1,1,1,0),(1,0,0,0),(0,0,0,0),(0,0,0,0)));
      T:Blocktype=( ((0,0,0,0),(0,1,0,0),(0,1,1,0),(0,1,0,0)),
                    ((0,0,0,0),(0,0,0,0),(0,0,1,0),(0,1,1,1)),
                    ((0,0,0,0),(0,0,1,0),(0,1,1,0),(0,0,1,0)),
                    ((0,0,0,0),(1,1,1,0),(0,1,0,0),(0,0,0,0)));
      I:Blocktype=( ((0,0,0,0),(0,0,0,0),(1,1,1,1),(0,0,0,0)),
                    ((0,1,0,0),(0,1,0,0),(0,1,0,0),(0,1,0,0)),
                    ((0,0,0,0),(0,0,0,0),(1,1,1,1),(0,0,0,0)),
                    ((0,1,0,0),(0,1,0,0),(0,1,0,0),(0,1,0,0)));
     L2:blocktype=( ((0,0,0,0),(0,0,1,0),(0,0,1,0),(0,1,1,0)),
                    ((0,0,0,0),(0,0,0,0),(1,0,0,0),(1,1,1,0)),
                    ((1,1,0,0),(1,0,0,0),(1,0,0,0),(0,0,0,0)),
                    ((0,1,1,1),(0,0,0,1),(0,0,0,0),(0,0,0,0)));
      O:blocktype=( ((0,0,0,0),(0,0,0,0),(0,1,1,0),(0,1,1,0)),
                    ((0,0,0,0),(0,0,0,0),(0,1,1,0),(0,1,1,0)),
                    ((0,0,0,0),(0,0,0,0),(0,1,1,0),(0,1,1,0)),
                    ((0,0,0,0),(0,0,0,0),(0,1,1,0),(0,1,1,0)));
      Z:blocktype=( ((0,0,0,0),(0,0,1,0),(0,1,1,0),(0,1,0,0)),
                    ((0,0,0,0),(0,0,0,0),(0,1,1,0),(0,0,1,1)),
                    ((0,0,0,0),(0,0,1,0),(0,1,1,0),(0,1,0,0)),
                    ((0,0,0,0),(0,0,0,0),(0,1,1,0),(0,0,1,1)));
     Z2:blocktype=( ((0,0,0,0),(0,1,0,0),(0,1,1,0),(0,0,1,0)),
                    ((0,0,0,0),(0,0,0,0),(0,0,1,1),(0,1,1,0)),
                    ((0,0,0,0),(0,1,0,0),(0,1,1,0),(0,0,1,0)),
                    ((0,0,0,0),(0,0,0,0),(0,0,1,1),(0,1,1,0)));
      n:blocktype=( ((0,0,0,0),(0,0,0,0),(0,1,1,1),(0,1,0,1)),
                    ((0,0,0,0),(0,0,1,1),(0,0,0,1),(0,0,1,1)),
                    ((0,0,0,0),(0,0,0,0),(0,1,0,1),(0,1,1,1)),
                    ((0,0,0,0),(0,0,1,1),(0,0,1,0),(0,0,1,1)));
     T2:Blocktype=( ((0,0,0,0),(0,1,0,0),(0,1,1,1),(0,1,0,0)),
                    ((0,0,0,0),(0,0,1,0),(0,0,1,0),(0,1,1,1)),
                    ((0,0,0,0),(0,0,1,0),(1,1,1,0),(0,0,1,0)),
                    ((0,0,0,0),(1,1,1,0),(0,1,0,0),(0,1,0,0)));
      
type
    blockinfo = object
           x  : byte;
           y  : byte;
    end;
    block     = object (blockinfo)
       struct : blocktype;
       color  : byte;
    end;
    appldas   = object
       blockjum : byte;
       B: array [1..9] of block;
       procedure putpiece(x,y,num,jenis,col:integer);
       procedure isiboard(x,y,num,jenis,col:integer);
       procedure drawpiece(x,y,col:integer);
    end;
    appl      = object (appldas)
       score     : longint;
       hiscore   : longint;
       function st(num:longint):string;
       procedure init;
       procedure initpiece;
       procedure hidepiece(x,y,num,jenis:integer);
       procedure colorpiece(x,y,num,jenis:integer);
       procedure drawnextpiece(num:integer);
       procedure drawboard;
       procedure redraw;
       function checkboardarray:boolean;
       procedure checkwin;
       procedure run;
       procedure done;
    end;

var boardarray : array [-3..24,-3..44] of integer;
    boardarraycolor : array [1..20,1..40] of integer;

procedure appl.drawboard;
var i:integer;
    f:text;
    space:string;
begin
   setfillstyle(8,random(9)+1);
   bar(0,0,getmaxx,getmaxy);
   setfillstyle(1,0);
   bar(220,50,420,450);
   setcolor(15);rectangle(220,50,420,450);
   setcolor(1);rectangle(219,49,421,451);
   setcolor(8);
   for i:=1 to 19 do line(220+(i*10),51,220+(i*10),449);
   for i:=1 to 39 do line(221,50+(i*10),419,50+(i*10));
   setcolor(1);rectangle(210,12,430,48);
   setcolor(8);rectangle(211,13,429,47);
   setfillstyle(3,12);bar(212,14,428,46);
   Setcolor(14);SettextStyle(3,horizdir,4);
   Outtextxy(220,8,'Ronald`sTetris');
   setcolor(10);Outtextxy(222,10,'Ronald`sTetris');
   setfillstyle(1,0);
   setcolor(13);
   rectangle(((-15+5)*10)+220,((-1)*10)+50,((-15+10)*10)+220,((1+4)*10)+50);
   bar(((-15+5)*10)+220+1,((-1)*10)+50+1,((-15+10)*10)+220-1,((1+4)*10)+50-1);
   settextstyle(2,horizdir,4);
   setcolor(10);
   setfillstyle(7,9);
   bar(((-15+5)*10)+220+1,((-1)*10)+50+1,((-15+10)*10)+220-1,(0*10)+50-1);
   outtextxy(131,39,'Score');
   setcolor(13);
   rectangle(((-15+5)*10)+220,(0*10)+50+1,((-15+10)*10)+220,(3*10)+50+1);
   settextstyle(2,horizdir,4);
   setcolor(7);
   outtextxy(130,60,'     0');
   assign(f,'hiscore.dat');
   {$I-}reset(f){$I+};
   if ioresult<>0 then hiscore:=0 else
   begin
     readln(f,hiscore);
   end;
   close(f);
   space:='';
   for i:=1 to 6-length(st(hiscore)) do space:=space+' ';
   setcolor(15);
   outtextxy(130,85,space+st(hiscore));
end;

procedure appldas.drawpiece;
begin
   if col>0 then setcolor(col-8) else setcolor(0);
   rectangle(((x-1)*10)+220+1,((y-1)*10)+50+1,(x*10)+220-1,(y*10)+50-1);
   setfillstyle(1,col);
   bar(((x-1)*10)+220+2,((y-1)*10)+50+2,(x*10)+220-2,(y*10)+50-2);
   if col<>0 then
   begin
      setcolor(7);
      line(((x-1)*10)+220+1,((y-1)*10)+50+1,(x*10)+220-1,((y-1)*10)+50+1);
      rectangle(((x-1)*10)+220+1,((y-1)*10)+50+1,((x-1)*10)+220+1,(y*10)+50-1);
   end;
end;

procedure appldas.putpiece;
var i,j,xplus,yplus:integer;
begin
   xplus:=0;
   yplus:=0;
   for j:=1 to 4 do
   begin
      xplus:=0;
      for i:=1 to 4 do
      begin
         if b[num].struct[jenis,i,j]=1 then
         begin
            drawpiece(x+(xplus div 10),y+(yplus div 10),col);
            if (x>-3) and (y>-3) then
            begin
               if col<>0 then boardarray[x+(xplus div 10),y+(yplus div 10)]:=boardarray[x+(xplus div 10),y+(yplus div 10)]+1
               else boardarray[x+(xplus div 10),y+(yplus div 10)]:=0;
               boardarraycolor[x+(xplus div 10),y+(yplus div 10)]:=col;
            end;
         end;
         xplus:=xplus+10;
      end;
      yplus:=yplus+10;
   end;
end;

procedure appldas.isiboard;
var i,j,xplus,yplus:integer;
begin
   xplus:=0;
   yplus:=0;
   for j:=1 to 4 do
   begin
      xplus:=0;
      for i:=1 to 4 do
      begin
         if b[num].struct[jenis,i,j]=1 then
         begin
           if col<>0 then boardarray[x+(xplus div 10),y+(yplus div 10)]:=boardarray[x+(xplus div 10),y+(yplus div 10)]+1
           else boardarray[x+(xplus div 10),y+(yplus div 10)]:=boardarray[x+(xplus div 10),y+(yplus div 10)]-1;
         end;
         xplus:=xplus+10;
      end;
      yplus:=yplus+10;
   end;
end;

procedure appl.hidepiece;
begin
   putpiece(x,y,num,jenis,0);
end;

procedure appl.colorpiece;
begin
   putpiece(x,y,num,jenis,b[num].color);
end;

procedure appl.init;
var g,m : integer;
begin
   g:=detect;
   m:=detect;
   {--- the initgraph directory must be pointing to your BGI directory --}
   initgraph(g,m,'c:\tp\bgi');
   blockjum :=9;
   for g:=-3 to 24 do
   for m:=-3 to 44 do boardarray[g,m]:=0;
   for g:=1 to 20 do
   for m:=1 to 40 do boardarraycolor[g,m]:=0;
end;

procedure appl.done;
var f:text;
begin
   if score>hiscore then
   begin
   assign(f,'hiscore.dat');
   rewrite(f);
   write(f,score);
   close(f)
   end;
   closegraph;
end;

procedure appl.initpiece;
begin
   b[1].struct:=L;b[1].color :=10;
   b[2].struct:=T;b[2].color :=15;
   b[3].struct:=I;b[3].color :=12;
   b[4].struct:=L2;b[4].color :=14;
   b[5].struct:=O;b[5].color :=9;
   b[6].struct:=Z;b[6].color :=11;
   b[7].struct:=Z2;b[7].color :=13;
   b[8].struct:=n;b[8].color :=9;
   b[9].struct:=T2;b[9].color:=12;
end;

function appl.checkboardarray:boolean;
var i,j:integer;
begin
   checkboardarray:=true;
   for j:=1 to 40 do
   for i:=21 to 24 do
   begin
      if boardarray[i,j]<>0 then checkboardarray:=false;
      if boardarray[i-24,j]<>0 then checkboardarray:=false;
   end;
   for j:=41 to 44 do
   for i:=1 to 24 do
   begin
      if boardarray[i,j]<>0 then checkboardarray:=false;
      if boardarray[i,j-44]<>0 then checkboardarray:=false;
   end;
   for j:=1 to 40 do
   for i:=1 to 20 do
   if boardarray[i,j]>1 then checkboardarray:=false;
end;

procedure appl.redraw;
var i,j:integer;
begin
   setfillstyle(0,0);bar(221,51,419,449);
   setcolor(8);
   for i:=1 to 19 do line(220+(i*10),51,220+(i*10),449);
   for i:=1 to 39 do line(221,50+(i*10),419,50+(i*10));
   for j:=1 to 40 do
   for i:=1 to 20 do
   begin
      drawpiece(i,j,boardarraycolor[i,j]);
   end;
end;

procedure appl.checkwin;
var i,j,ni,nj:integer;
    hilang:boolean;
begin
for j:=40 downto 1 do
begin
   hilang:=true;
   for i:=1 to 20 do if boardarray[i,j]=0 then hilang:=false;
   if hilang then
   begin
      score:=score+100;
      for i:=1 to 20 do
      begin
         boardarray[i,j]:=0;
         boardarraycolor[i,j]:=0;
      end;
      for nj:=j downto 2 do
      for ni:=1 to 20 do
      begin
         boardarray[ni,nj]:=boardarray[ni,nj-1];
         boardarraycolor[ni,nj]:=boardarraycolor[ni,nj-1];
      end;
      for ni:=1 to 20 do
      begin
         boardarray[ni,1]:=0;
         boardarraycolor[ni,1]:=0;
      end;
      redraw;
   end;
end;
end;

procedure appl.drawnextpiece;
var i,j:integer;
begin
   setcolor(6);
   setfillstyle(1,0);
   bar(((-15-1)*10)+220+1,((-2)*10)+50+1,((-15+4)*10)+220-1,((1+4)*10)+50-1);
   setfillstyle(8,9);
   bar(((-15-1)*10)+220+1,((-2)*10)+50+1,((-15+4)*10)+220-1,((-1*10))+50);
   settextstyle(2,horizdir,5);
   outtextxy(70,27,'Next');
   setcolor(14);
   outtextxy(72,27,'Next');
   setcolor(10);
   rectangle(((-15-1)*10)+220+1,((-1)*10)+50+1,((-15+4)*10)+220-1,((1+4)*10)+50-1);
   rectangle(((-15-1)*10)+220+1,((-2)*10)+50,((-15+4)*10)+220-1,((1+4)*10)+50-1);
   colorpiece(-15,1,num,1);
end;

function appl.st;
var s:string;
begin
  str(num,s);
  st:=s;
end;

procedure appl.run;
var n,n2,lastx,i,j,jenis,piece,nextpiece:integer;
    ch:char;
    space:string;
    speed,speed2:longint;
    down:boolean;
    finishdown:boolean;
    check:byte;
    gameover:boolean;
begin
   initpiece;
   drawboard;
   nextpiece:=random(blockjum)+1;
   repeat
      piece:=nextpiece;
      nextpiece:=random(blockjum)+1;
      drawnextpiece(nextpiece);
      down:=false;
      jenis:=1;
      j:=1;
      if score div 1000<9 then
      begin
        speed2:=900- (((score) div 1000)*100);speed:= 900- (((score) div 1000)*100);
      end else
      begin
         if score div 1000<12 then
         begin
           speed2:=50;speed:=50;
         end else
         begin
           speed2:=30;speed:=30;
         end;
      end;
      i:=10;
      finishdown:=false;
      repeat
         if speed2>=speed then
         begin
            hidepiece(i,j,piece,jenis);
            inc(j);
            isiboard(i,j,piece,jenis,1);
            if not checkboardarray then
            begin
               finishdown:=true;
               isiboard(i,j,piece,jenis,0);
               j:=j-1;
            end;
            colorpiece(i,j,piece,jenis);
            speed2:=0;
         end else
         begin
            delay(1);
            speed2:=speed2+1;
         end;
         if keypressed then
         begin
            if not finishdown then hidepiece(i,j,piece,jenis);
            ch:=readkey;
            if ch=#0 then ch:=readkey;
            case ch of
            ' ' , #72 : begin
                 inc(jenis);
                 if jenis>4 then jenis:=1;
                 isiboard(i,j,piece,jenis,1);
                 if not checkboardarray then
                 begin
                 isiboard(i,j,piece,jenis,0);
                 jenis:=jenis-1;
                 if jenis<1 then jenis:=4;
                 end else hidepiece(i,j,piece,jenis);
                 end;
            #77 : begin
                 i:=i+1;
                 isiboard(i,j,piece,jenis,1);
                 if not checkboardarray then
                 begin
                 isiboard(i,j,piece,jenis,0);
                 i:=i-1;
                 end else isiboard(i,j,piece,jenis,0);
                 end;
            #75 : begin
                 i:=i-1;
                 isiboard(i,j,piece,jenis,1);
                 if not checkboardarray then
                 begin
                 isiboard(i,j,piece,jenis,0);
                 i:=i+1;
                 end else isiboard(i,j,piece,jenis,0);
                 end;
            #80 : if not down then
                 begin
                 down:=true;
                 speed:=speed div 20;
                 end;
            end;
            colorpiece(i,j,piece,jenis);
         end;
         gameover:=false;
         for check:=1 to 20 do
         if (boardarray[check,2]=1) and (finishdown)then gameover:=true;
         if ch in [#13] then repeat until keypressed;
      until finishdown or (ch=#27) or gameover;
      for check:=1 to 4 do checkwin;
      if finishdown then
      begin
         score:=score+2;
         sound(250);delay(20);nosound;
      end;
      setfillstyle(1,0);
      bar(((-15+5)*10)+220+1,(0*10)+50+2,((-15+10)*10)+220-1,((1+2)*10)+50-1);
      settextstyle(2,horizdir,4);
      space:='';
      for check:=1 to 6-length(st(score)) do space:=space+' ';
      setcolor(7);
      outtextxy(130,60,space+st(score));
   until (ch=#27) or gameover;
end;

var app:appl;

begin
   randomize;
   app.init;
   app.run;
   app.done;
end.